//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma link "Grids"
#pragma resource "*.dfm"
TForm1 *Form1;

typedef struct
{
   Db::TFieldType  nCode;
   char *strDesc;
} DbFieldType;

DbFieldType sFieldTypes[] = 
{
	{ftUnknown, "   "},
	{ftString, "   "},
	{ftSmallint, "16-  "},
	{ftInteger, "32-  "},
	{ftWord, "16-   "},
	{ftBoolean, " "},
	{ftFloat, "    "},
	{ftCurrency, " "},
	{ftBCD, "-  "},
	{ftDate, " "},
	{ftTime, " "},
	{ftDateTime, "   "},
	{ftBytes, "   ( )"},
	{ftVarBytes, "   ( "},
	{ftAutoInc, "  32-   "},
	{ftBlob, " Binary Large Object (  )"},
	{ftMemo, " memo (  )"},
	{ftGraphic, "  "},
	{ftFmtMemo, "  memo"},
	{ftParadoxOle, " Paradox OLE"},
	{ftDBaseOle, " dBase OLE"},
	{ftTypedBinary, "  "},
};

#define NumberOfFieldTypes (sizeof(sFieldTypes)/sizeof(sFieldTypes[0]))

//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
	: TForm(Owner)
{
	Table1=new TTable(this);
	Table1->Active = false;
	Table1->FieldDefs->Clear();
	Table1->IndexDefs->Clear();

}
//--------------------------------------------------------------------------- 
void __fastcall TForm1::Button1Click(TObject *Sender)
{
	//       
	Table1->DatabaseName = Edit3->Text;
	Table1->TableName = Edit4->Text;

	//     dBase
	Table1->TableType = ttDBase;

	//  
	Table1->CreateTable();

	//  
	delete Table1;

	//  
	MessageBox(NULL, "  !", "", MB_OK );

	//  
	Application->Terminate();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormCreate(TObject *Sender)
{
	StringGrid1->ColCount = 5;
	StringGrid1->Cells[0][0] = "";
	StringGrid1->Cells[1][0] = "";
	StringGrid1->Cells[2][0] = "";
	StringGrid1->Cells[3][0] = "";
	StringGrid1->Cells[4][0] = "";
	StringGrid1->RowCount = 1;

	//   
	for ( int i=0; i<NumberOfFieldTypes; ++i )
    {
		ComboBox1->Items->Add( sFieldTypes[i].strDesc );
	}
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button2Click(TObject *Sender)
{
	char szBuffer[ 80 ];
	strcpy ( szBuffer, Edit2->Text.c_str() );
	unsigned short nSize = (unsigned short)atoi(szBuffer);
 
	// ,    
	if ( sFieldTypes[ComboBox1->ItemIndex].nCode != ftString )
		nSize = 0;

	//   
	Table1->FieldDefs->Add(Edit1->Text,
      sFieldTypes[ComboBox1->ItemIndex].nCode, nSize, CheckBox1->Checked);

	//    
	StringGrid1->RowCount++;

	//    
	int nRow = StringGrid1->RowCount-1;
	StringGrid1->Cells[0][nRow] = AnsiString(nRow);
	StringGrid1->Cells[1][nRow] = Edit1->Text;
	StringGrid1->Cells[2][nRow] = sFieldTypes[ComboBox1->ItemIndex].strDesc;
	StringGrid1->Cells[3][nRow] = Edit2->Text;
	if ( CheckBox1->Checked )
		StringGrid1->Cells[4][nRow] = "";
	else
		StringGrid1->Cells[4][nRow] = "";
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ComboBox1Change(TObject *Sender)
{
   if ( sFieldTypes[ComboBox1->ItemIndex].nCode != ftString )
   {
      Edit2->Enabled = false;
   }
   else
      Edit2->Enabled = true;
}
//---------------------------------------------------------------------------